from os.path import dirname, getsize, isfile
from subprocess import call

from humbleclient.utils import *

def wget(url, dest, dryrun=False):
    cmdline = ["wget", "-c", "-O", dest, url]
    
    if dryrun:
        print(" ".join('"' + x + '"' for x in cmdline))
    else:
        makedirs(dirname(dest))
        call(cmdline)

class Downloader:
    def __init__(self, dryrun=False):
        self._dryrun = dryrun
    
    def get(self, url, dest, size=None):
        if size is not None:
            if isfile(dest) and size == getsize(dest):
                print("Nothing to do for", dest)
                return
        wget(url, dest, self._dryrun)
